(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common/http'), require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@yukawa/chain-base-angular-domain')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-base-angular-client', ['exports', '@angular/common/http', '@angular/core', 'rxjs', 'rxjs/operators', '@yukawa/chain-base-angular-domain'], factory) :
    (global = global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa['chain-base-angular-client'] = {}), global.ng.common.http, global.ng.core, global.rxjs, global.rxjs.operators, global['@yukawa/chain-base-angular-domain']));
}(this, (function (exports, http, core, rxjs, operators, chainBaseAngularDomain) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ConfigService = /** @class */ (function () {
        function ConfigService(http) {
            this.http = http;
            this.configUrl = "config.json";
            //this.initConfig();
        }
        /**
         * @return {?}
         */
        ConfigService.prototype.initConfig = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                _this.loadConfig()
                    .subscribe((/**
                 * @param {?} data
                 * @return {?}
                 */
                function (data) {
                    _this.config = data;
                    resolve(true);
                }), (/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) {
                    console.error("ConfigService initConfig  " + error);
                    return rxjs.Observable.throw(error || 'Server error');
                }));
            }));
        };
        /**
         * @param {?=} id
         * @return {?}
         */
        ConfigService.prototype.getBaseUrl = /**
         * @param {?=} id
         * @return {?}
         */
        function (id) {
            if (id === void 0) { id = ""; }
            return id == "" ? this.config.baseUrl : this.config[id];
        };
        /**
         * @param {?=} id
         * @return {?}
         */
        ConfigService.prototype.getConfig = /**
         * @param {?=} id
         * @return {?}
         */
        function (id) {
            if (!id)
                return this.config;
            return "" + this.getBaseUrl() + this.config[id];
        };
        /**
         * @return {?}
         */
        ConfigService.prototype.loadConfig = /**
         * @return {?}
         */
        function () {
            return this.http.get(this.configUrl);
        };
        ConfigService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        ConfigService.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        /** @nocollapse */ ConfigService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ConfigService_Factory() { return new ConfigService(core.ɵɵinject(http.HttpClient)); }, token: ConfigService, providedIn: "root" });
        return ConfigService;
    }());
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        ConfigService.prototype.configUrl;
        /** @type {?} */
        ConfigService.prototype.config;
        /**
         * @type {?}
         * @protected
         */
        ConfigService.prototype.http;
    }
    /**
     * @param {?} config
     * @return {?}
     */
    function ConfigFactory(config) {
        return (/**
         * @return {?}
         */
        function () { return config.initConfig(); });
    }
    /**
     * @return {?}
     */
    function init() {
        return {
            provide: core.APP_INITIALIZER,
            useFactory: ConfigFactory,
            deps: [ConfigService],
            multi: true
        };
    }
    /** @type {?} */
    var ConfigModule = {
        init: init
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var TAG = 'RestAspect';
    /**
     * @abstract
     */
    var   /**
     * @abstract
     */
    RestAspect = /** @class */ (function () {
        function RestAspect(http, configService, serviceUrl) {
            this.http = http;
            this.configService = configService;
            this.serviceUrl = serviceUrl;
        }
        /**
         * @protected
         * @param {?=} path
         * @return {?}
         */
        RestAspect.prototype.formatBaseUrl = /**
         * @protected
         * @param {?=} path
         * @return {?}
         */
        function (path) {
            if (path === void 0) { path = ''; }
            return this.configService.getConfig('baseUrl') + path;
        };
        /**
         * @protected
         * @param {?=} path
         * @return {?}
         */
        RestAspect.prototype.formatServiceUrl = /**
         * @protected
         * @param {?=} path
         * @return {?}
         */
        function (path) {
            if (path === void 0) { path = ''; }
            return this.serviceUrl + path + '/';
        };
        Object.defineProperty(RestAspect.prototype, "verbose", {
            // noinspection JSMethodCanBeStatic
            get: 
            // noinspection JSMethodCanBeStatic
            /**
             * @return {?}
             */
            function () {
                return core.isDevMode();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @protected
         * @template E
         * @param {?} url
         * @param {?} filter
         * @param {?=} method
         * @return {?}
         */
        RestAspect.prototype.search = /**
         * @protected
         * @template E
         * @param {?} url
         * @param {?} filter
         * @param {?=} method
         * @return {?}
         */
        function (url, filter, method) {
            if (method === void 0) { method = 'post'; }
            /** @type {?} */
            var m = method || 'post';
            if (this.verbose)
                console.debug(TAG, "search:", m, url, filter);
            return this.http[m](url, filter).pipe(operators.map((/**
             * @param {?} r
             * @return {?}
             */
            function (r) {
                /** @type {?} */
                var result = (/** @type {?} */ ({
                    took: (/** @type {?} */ (r.took)),
                    timedOut: (/** @type {?} */ (r.timed_out)),
                    rows: (/** @type {?} */ ([]))
                }));
                /** @type {?} */
                var h = r.hits;
                if (h) {
                    result.total = h.total;
                    for (var idx = 0; idx < h.hits.length; idx++) {
                        /** @type {?} */
                        var hit = h.hits[idx];
                        /** @type {?} */
                        var source = (/** @type {?} */ (hit._source));
                        // console.log('DeviceService', hit);
                        result.rows.push(source);
                    }
                }
                return result;
            })));
        };
        /**
         * @protected
         * @template E
         * @param {?} url
         * @param {?} filter
         * @param {?=} options
         * @return {?}
         */
        RestAspect.prototype.query = /**
         * @protected
         * @template E
         * @param {?} url
         * @param {?} filter
         * @param {?=} options
         * @return {?}
         */
        function (url, filter, options) {
            if (options === void 0) { options = {}; }
            //options = this.defaultOptions(options);
            if (this.verbose)
                console.debug(TAG, "query:", url, filter);
            return this.http.post(url, filter, options).pipe(operators.map((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { return chainBaseAngularDomain.QueryResult.fromData(data); })));
        };
        /**
         * @protected
         * @template E
         * @param {?} url
         * @param {?=} value
         * @param {?=} options
         * @return {?}
         */
        RestAspect.prototype.edit = /**
         * @protected
         * @template E
         * @param {?} url
         * @param {?=} value
         * @param {?=} options
         * @return {?}
         */
        function (url, value, options) {
            if (value === void 0) { value = null; }
            if (options === void 0) { options = {}; }
            if (this.verbose)
                console.debug(TAG, "edit:", url, value);
            return (options.method === 'put'
                ? this.http.put(url, value, options)
                : this.http.post(url, value, options)).pipe(operators.map((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { return chainBaseAngularDomain.EditResult.fromData(data); })));
        };
        /**
         * @protected
         * @template E
         * @param {?} url
         * @param {?=} value
         * @param {?=} options
         * @return {?}
         */
        RestAspect.prototype.load = /**
         * @protected
         * @template E
         * @param {?} url
         * @param {?=} value
         * @param {?=} options
         * @return {?}
         */
        function (url, value, options) {
            if (value === void 0) { value = null; }
            if (options === void 0) { options = {}; }
            if (this.verbose)
                console.debug(TAG, "load:", url);
            /** @type {?} */
            var method = options.method || 'get';
            /** @type {?} */
            var obs;
            if (value) {
                obs = this.http[method](url, value, options);
            }
            else {
                obs = this.http[method](url, options);
            }
            return obs;
        };
        /**
         * @protected
         * @param {?} url
         * @param {?=} filter
         * @param {?=} options
         * @return {?}
         */
        RestAspect.prototype.download = /**
         * @protected
         * @param {?} url
         * @param {?=} filter
         * @param {?=} options
         * @return {?}
         */
        function (url, filter, options) {
            if (filter === void 0) { filter = null; }
            if (options === void 0) { options = {}; }
            if (this.verbose)
                console.debug(TAG, "download:", url, filter);
            options = options || {};
            options.responseType = options.responseType || (/** @type {?} */ ('blob'));
            /** @type {?} */
            var method = options.method || 'post';
            return this.http[method](url, filter, options);
        };
        /**
         * @protected
         * @param {?} value
         * @param {?=} message
         * @return {?}
         */
        RestAspect.prototype.checkNotNull = /**
         * @protected
         * @param {?} value
         * @param {?=} message
         * @return {?}
         */
        function (value, message) {
            if (message === void 0) { message = "Not found"; }
            if (value == null)
                throw new Error(message);
            return value;
        };
        return RestAspect;
    }());
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        RestAspect.prototype.http;
        /**
         * @type {?}
         * @protected
         */
        RestAspect.prototype.configService;
        /**
         * @type {?}
         * @protected
         */
        RestAspect.prototype.serviceUrl;
    }

    exports.ConfigFactory = ConfigFactory;
    exports.ConfigModule = ConfigModule;
    exports.ConfigService = ConfigService;
    exports.RestAspect = RestAspect;
    exports.init = init;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yukawa-chain-base-angular-client.umd.js.map
