import { HttpClient } from '@angular/common/http';
import { Observable } from "rxjs";
import { EditResult, QueryResult, SearchResult } from "@yukawa/chain-base-angular-domain";
import { ConfigService } from "../config/config.service";
export declare abstract class RestAspect {
    protected http: HttpClient;
    protected configService: ConfigService;
    protected serviceUrl?: string;
    protected constructor(http: HttpClient, configService: ConfigService, serviceUrl?: string);
    protected formatBaseUrl(path?: string): string;
    protected formatServiceUrl(path?: string): string;
    readonly verbose: boolean;
    protected search<E>(url: string, filter: any, method?: string): Observable<SearchResult<E>>;
    protected query<E>(url: string, filter: any, options?: any): Observable<QueryResult<E>>;
    protected edit<E>(url: string, value?: any, options?: any): Observable<EditResult>;
    protected load<E>(url: string, value?: any, options?: any): Observable<EditResult>;
    protected download(url: string, filter?: any, options?: any): Observable<Blob>;
    protected checkNotNull(value: any, message?: string): any;
}
